# Author: Logan Tucker
# Date: 11.8.21
# Purpose: Sort a list of objects


# Purpose: sort a list so that all numbers less than a "pivot" value come before all number greater than that value
# Parameters: (the_list) a list of city objects. (p) interg and starting index of a sublist to be partitioned.
# (r) integer and end value of a sublist to be partitioned. (compare_func) function that determines which attribute of
# the objects to sort by
def partition(the_list, p, r, compare_func):
    pivot = the_list[r]
    i = p - 1
    j = p

    while j <= r:
        if compare_func(the_list[j], pivot):
            i += 1

            tmp = the_list[i]
            the_list[i] = the_list[j]
            the_list[j] = tmp

            j += 1

        else:
            j += 1

    return i  # current index of the pivot value


# Purpose: Sort a list of items by recursively partitioning smaller and smaller sub-lists
# Parameters: (the_list) a list of city objects. (p) integer and starting index of a sublist to be partitioned. (r)
# integer and end value of a sublist to be partitioned. (compare_func) function that determines which attribute of the
# objects to sort by
def quicksort(the_list, p, r, compare_func):
    if (r - p) > 0:
        q = partition(the_list, p, r, compare_func)

        quicksort(the_list, p, (q - 1), compare_func)  # lesser values
        quicksort(the_list, (q + 1), r, compare_func)  # greater values

    return the_list


# Purpose: call the quicksort function to sort the entire list referenced by the_list
# Parameters: (the_list) a list of city objects. (compare_func) function that determines which attribute of the objects
# to sort by
def sort(the_list, compare_func):
    quicksort(the_list, 0, (len(the_list) - 1), compare_func)

