# Author: Logan Tucker
# Date: 11.8.21
# Purpose: Display cities on a world map in order of an attribute


from cs1lib import *
from sort_cities import *


# define constants
HEIGHT = 360
WIDTH = 720

EQUATOR = HEIGHT / 2
PRIME_MERIDIAN = WIDTH / 2

LAT_MAX = 90
LONG_MAX = 180

N = 479134  # number of cities to display
MAP = load_image("world.png")  # load world map

CITY_SIZE = 3


# define variables
i = 0
clist = read("world_cities.txt")


# Determine by which attribute you'd like to order the display of cities
pop_sort(clist)  # order by population


# Purpose: Display the world map
# Parameters: None
def draw_world():
    draw_image(MAP, 0, 0)


# Purpose: Draw a city on the map as a circle
# Parameters: (city) a city object
def draw_city(city):
    set_fill_color(1, .5, 0)
    draw_circle(PRIME_MERIDIAN + ((city.longitude / LONG_MAX) * PRIME_MERIDIAN), EQUATOR - ((city.latitude / LAT_MAX) *
                                                                                            EQUATOR), CITY_SIZE)


# Purpose: Draw N number of cities on the world map
# Parameters: None
def draw_cities():
    global i

    if i == 0:
        draw_world()

    if i < N:
        draw_city(clist[i])
        i += 1


start_graphics(draw_cities, framerate=2, height=HEIGHT, width=WIDTH)




